/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AwsS3StorageRequestAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AwsS3StorageRequestAllOf{}

// AwsS3StorageRequestAllOf struct for AwsS3StorageRequestAllOf
type AwsS3StorageRequestAllOf struct {
	OAuthId *int32         `json:"o_auth_id,omitempty"`
	Path    NullableString `json:"path,omitempty"`
}

// NewAwsS3StorageRequestAllOf instantiates a new AwsS3StorageRequestAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAwsS3StorageRequestAllOf() *AwsS3StorageRequestAllOf {
	this := AwsS3StorageRequestAllOf{}
	return &this
}

// NewAwsS3StorageRequestAllOfWithDefaults instantiates a new AwsS3StorageRequestAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAwsS3StorageRequestAllOfWithDefaults() *AwsS3StorageRequestAllOf {
	this := AwsS3StorageRequestAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *AwsS3StorageRequestAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AwsS3StorageRequestAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *AwsS3StorageRequestAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *AwsS3StorageRequestAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetPath returns the Path field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AwsS3StorageRequestAllOf) GetPath() string {
	if o == nil || IsNil(o.Path.Get()) {
		var ret string
		return ret
	}
	return *o.Path.Get()
}

// GetPathOk returns a tuple with the Path field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AwsS3StorageRequestAllOf) GetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Path.Get(), o.Path.IsSet()
}

// HasPath returns a boolean if a field has been set.
func (o *AwsS3StorageRequestAllOf) HasPath() bool {
	if o != nil && o.Path.IsSet() {
		return true
	}

	return false
}

// SetPath gets a reference to the given NullableString and assigns it to the Path field.
func (o *AwsS3StorageRequestAllOf) SetPath(v string) {
	o.Path.Set(&v)
}

// SetPathNil sets the value for Path to be an explicit nil
func (o *AwsS3StorageRequestAllOf) SetPathNil() {
	o.Path.Set(nil)
}

// UnsetPath ensures that no value is present for Path, not even an explicit nil
func (o *AwsS3StorageRequestAllOf) UnsetPath() {
	o.Path.Unset()
}

func (o AwsS3StorageRequestAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AwsS3StorageRequestAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if o.Path.IsSet() {
		toSerialize["path"] = o.Path.Get()
	}
	return toSerialize, nil
}

type NullableAwsS3StorageRequestAllOf struct {
	value *AwsS3StorageRequestAllOf
	isSet bool
}

func (v NullableAwsS3StorageRequestAllOf) Get() *AwsS3StorageRequestAllOf {
	return v.value
}

func (v *NullableAwsS3StorageRequestAllOf) Set(val *AwsS3StorageRequestAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableAwsS3StorageRequestAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableAwsS3StorageRequestAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAwsS3StorageRequestAllOf(val *AwsS3StorageRequestAllOf) *NullableAwsS3StorageRequestAllOf {
	return &NullableAwsS3StorageRequestAllOf{value: val, isSet: true}
}

func (v NullableAwsS3StorageRequestAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAwsS3StorageRequestAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
